import os
import re
import console

def get_app_class(template):
    class App(template):
        def F_main(self):
            pattern = self.argv[1].encode("utf-8")
            file = self.argv[2]

            try:
                with open(file, "rb") as f:
                    for line in f.readlines():
                        if re.search(pattern, line):
                            self.console.write(line)
            except OSError as e:
                try:
                    os.listdir(file)
                    console.print(self.console, f"grep: {file}: Is a directory")
                except OSError:
                    console.print(self.console, f"grep: {file}: No such file or directory")

            self.exit()

    return App
